## vdrift 0.0.2006.10.06

=== SConstruct ===
import os, errno, SCons
from time import gmtime, strftime

#---------------#
# Build Options #
#---------------#
opts = Options('vdrift.conf', ARGUMENTS)
opts.Add('settings', 'Directory under user\'s home dir where settings will be stored', '.vdrift')
opts.Add('destdir', 'Staging area to install VDrift to.  Useful for packagers. ', '')
opts.Add('prefix', 'Path prefix.', '/usr') # Can't be /usr/local, it is HARDCODED in default VDrift.config
opts.Add('datadir', 'Path suffix where where VDrift data will be installed', "share/games/vdrift/data") # in most case this dir doesn't exsist => do not use PathOption (Fails on build)
opts.Add('bindir', 'Path suffix where vdrift binary executable will be installed', "share/games/vdrift/bin")
opts.Add('localedir', 'Path suffix were vdrift locales (.mo files) will be installed', "share/locale")
opts.Add('arch', 'Target architecture to compile vdrift for (x86, p4, axp, a64)', 'x86')
opts.Add(BoolOption('minimal', 'Only install minimal data (3 cars and 2 tracks)', 0))
opts.Add(BoolOption('cache', 'Cache options in vdrift.conf', 1))
opts.Add(BoolOption('release', 'Turn off debug option during build', 0))
opts.Add(BoolOption('old_openal', 'Set this to 1 if your compile fails due to missing alut functions in sound code.', 0))
opts.Add(BoolOption('use_gcc_32', 'Set this to 1 if the game runs fine but the cars bounce around (gcc4 bug).', 0))
opts.Add(BoolOption('use_gcc_33', 'Set this to 1 if the game runs fine but the cars bounce around (gcc4 bug).', 0))
opts.Add(BoolOption('use_gcc_34', 'Set this to 1 if the game runs fine but the cars bounce around (gcc4 bug).', 0))
opts.Add(BoolOption('use_apbuild', 'Set this to 1 if you want to compile with apgcc to create an autopackage', 0))
opts.Add(BoolOption('use_binreloc', 'Set this to 1 if you want to compile with Binary Relocation support', 1))
opts.Add(BoolOption('os_cc', 'Set this to 1 if you want to use the operating system\'s C compiler environment variable.', 0))
opts.Add(BoolOption('os_cxx', 'Set this to 1 if you want to use the operating system\'s C++ compiler environment variable.', 0))
opts.Add(BoolOption('os_cxxflags', 'Set this to 1 if you want to use the operating system\'s C++ compiler flags environment variable.', 0))
opts.Add(BoolOption('NLS', 'Set this to 1 to turn on i18n support', 1))


#--------------------------#
# Create Build Environment #
#--------------------------#
oscmd = os.popen('uname')
osinf = oscmd.readlines()
for i in osinf:
#-------------------------------#
# Section used for FreeBSD port #
#-------------------------------#
	if i == 'FreeBSD\n':
		LOCALBASE = os.environ['LOCALBASE']
		X11BASE = os.environ['X11BASE']

		env = Environment(ENV = os.environ,
			CPPPATH = ['#include',LOCALBASE + '/include', LOCALBASE + '/include/AL',X11BASE + '/include'],
			LIBPATH = ['.', '#lib', LOCALBASE + '/lib', X11BASE + '/lib'],
			LINKFLAGS = ['-pthread','-lintl'],
			options = opts)
         
		check_headers = ['GL/gl.h', 'GL/glu.h', 'SDL/SDL.h', 'SDL/SDL_image.h', 'SDL/SDL_net.h']
         
		env.Replace(CC = os.environ['CC'])
		env.Replace(CXX = os.environ['CXX'])
		env.Append(CXXFLAGS = os.environ['CXXFLAGS'])
#----------------------------------#
# Section used for GNU/Linux build #
#----------------------------------#
	if i == 'Linux\n':
		env = Environment(ENV = os.environ,
			CPPPATH = ['#include'],
			CCFLAGS = ['-Wall', '-Wno-non-virtual-dtor'],
			LIBPATH = ['.', '#lib'],
		        options = opts)
         
		check_headers = ['GL/gl.h', 'GL/glu.h', 'SDL/SDL.h', 'SDL/SDL_image.h', 'SDL/SDL_net.h', 'AL/al.h', 'AL/alc.h', 'AL/alut.h']

#--------------#
# Save Options #
#--------------#
opts.Update(env)

if env['cache']:
    opts.Save('vdrift.conf', env)

#--------------------------------------------#
# distcopy and tarballer functions           #
# by Paul Davis <paul@linuxaudiosystems.com> #
#--------------------------------------------#

def distcopy (target, source, env):
    treedir = str (target[0])

    try:
        os.mkdir (treedir)
    except OSError, (errnum, strerror):
        if errnum != errno.EEXIST:
            print 'mkdir ', treedir, ':', strerror

    cmd = 'tar cf - '
    #
    # we don't know what characters might be in the file names
    # so quote them all before passing them to the shell
    #
    all_files = ([ str(s) for s in source ])
    cmd += " ".join ([ "'%s'" % quoted for quoted in all_files])
    cmd += ' | (cd ' + treedir + ' && tar xf -)'
    p = os.popen (cmd)
    return p.close ();

def tarballer (target, source, env):            
    cmd = 'tar -jcf ' + str (target[0]) +  ' ' + str(source[0])
    #cmd = 'tar -jcf ' + str (target[0]) +  ' ' + str(source[0]) + "  --exclude '*~' "
    print 'running ', cmd, ' ... '
    p = os.popen (cmd)
    return p.close ()

dist_bld = Builder (action = distcopy,
                    target_factory = SCons.Node.FS.default_fs.Entry,
                    source_factory = SCons.Node.FS.default_fs.Entry,
                    multi = 1)

tarball_bld = Builder (action = tarballer,
                       target_factory = SCons.Node.FS.default_fs.Entry,
                       source_factory = SCons.Node.FS.default_fs.Entry)

env.Append (BUILDERS = {'Distribute' : dist_bld})
env.Append (BUILDERS = {'Tarball' : tarball_bld})

#--------------------------------------------------#
# Builder for untarring something into another dir #
#--------------------------------------------------#
def tarcopy(target, source, env):
    cmd = 'tar zxf ' + source + ' -C ' + target
    p = os.popen(cmd)
    return p.close()

copy_tar_dir = Builder (action = tarcopy,
                        target_factory = SCons.Node.FS.default_fs.Entry,
                        source_factory = SCons.Node.FS.default_fs.Entry)

env.Append (BUILDERS = {'TarCopy' : copy_tar_dir})

#------------#
# Build Help #
#------------#
Help("""
Type: 'scons' to compile with the default options.
      'scons arch=axp' to compile for Athlon XP support (other options: a64, p4, x86)
      'scons prefix=/usr/local' to install everything in another prefix.
      'scons destdir=$PWD/tmp' to install to $PWD/tmp staging area.
      'scons datadir= to install data files into an alternate directory'
      'scons bindir=games/bin' to executable into an alternate directory.
      'scons localedir=share/locale' to install translation into an alternate directory.
      'scons release=1' to turn off compiler optimizations and debugging info.
      'scons settings=.VDrift' to change settings directory.
      'scons install' (as root) to install VDrift.
      'scons old_openal=1' to use old OpenAL functions.
      'scons use_gcc_3.2=1' to use g++-3.2 instead of the default.
      'scons use_gcc_3.3=1' to use g++-3.3 instead of the default.
      'scons use_gcc_3.4=1' to use g++-3.4 instead of the default.
      'scons use_apbuild=1' to create an autopackage (building with apbuild)
      'scons use_binreloc=0' to turn off binary relocation support
      'scons os_cc=1' to use the operating system's C compiler environment variable
      'scons os_cxx=1' to use the operating system's C++ compiler environment variable
      'scons os_cxxflags=1' to use the operating system's C++ compiler flags environment variable
      'scons NLS=0' To disable internationalization support (An english-only version will be built)
%s 

Note: The options you enter will be saved in the file vdrift.conf and they will be the defaults whice are used every subsequent time you run scons.""" % opts.GenerateHelpText(env))

#--------------------------#
# Check for Libs & Headers #
#--------------------------#
conf = Configure(env)

check_libs = ['openal']

for lib in check_libs:
    if not conf.CheckLib(lib):
        print 'You do not have the %s library installed. Exiting.' % lib
        Exit(1)

# check for alut, but don't exit if it's not there (unless user wants to use new openal)
# otherwise just note its absence
env['alut_found'] = 1
#if not conf.CheckLib('alut'):
#    env['alut_found'] = 0
#    if not env['old_openal']:
#        print 'If you have the newer version of OpenAL, you also need the OpenAL Utility Toolkit or ALUT library. Get it from http://openal.org/. If you are using an older version of OpenAL, you do not need this because it\'s built in. Try compiling with old_openal=1.'
#	Exit(1)

for header in check_headers:
    if not conf.CheckCXXHeader(header):
        print 'You do not have the %s headers installed. Exiting.' % header
        Exit(1)

#-------------#
# directories #
#-------------#
env['data_directory'] = env['destdir'] + env['prefix'] + '/' + env['datadir']

#--------------#
# i18n support # 
#--------------#

if env['NLS']:
    #print 'Checking for internationalization support ...'
    have_gettext = conf.TryAction(Action('xgettext --version'))
    if not have_gettext[0]:
        print 'This system is not configured for internationalized applications (no xgettext command). An english-only version will be built\n'
        env['NLS'] = 0

    if not conf.CheckCHeader('libintl.h'):
        print 'This system is not configured for internationalized applications (no libintl.h). An english-only ersion will be built\n'
        env['NLS'] = 0

env = conf.Finish()

#---------------#
# Debug/release #
#---------------#
if env['release']:
    # release build, debugging off, optimizations on
    env.Append(CCFLAGS = ['-O2'])
else:
    # debug build, lots of debugging, no optimizations
    env.Append(CCFLAGS = ['-g3'])
    env.Append(CPPDEFINES = [('DEBUG','1')])

#-------------#
# g++ version #
#-------------#
if env['use_gcc_32']:
    # change the compiler version to 3.2 to work around gcc4 bugs
    env.Append(CXX = '-3.2')

if env['use_gcc_33']:
    # change the compiler version to 3.2 to work around gcc4 bugs
    env.Append(CXX = '-3.3')

if env['use_gcc_34']:
    # change the compiler version to 3.4 to work around gcc4 bugs
    env.Append(CXX = '-3.4')

if env['use_apbuild']:
    env['CXX'] = 'apg++'
    env['CC'] = 'apgcc'

if env['use_binreloc']:
    env.Append(CPPDEFINES = 'ENABLE_BINRELOC')

#----------------------#
# OS compiler settings #
#----------------------#
if env['os_cc']:
    env.Replace(CC = os.environ['CC'])

if env['os_cxx']:
    env.Replace(CXX = os.environ['CXX'])

if env['os_cxxflags']:
    env.Append(CXXFLAGS = os.environ['CXXFLAGS'])

#------------------------------------#
# Target architecture to compile for #
#------------------------------------#
#if env['arch'] == 'x86':
#    env.Append(CCFLAGS="-march= -mtune=generic")
if env['arch'] == 'axp':
    env.Append(CCFLAGS="-march=athlon-xp")
elif env['arch'] == 'p4':
    env.Append(CCFLAGS="-march=pentium4")
elif env['arch'] == 'a64':
    env.Append(CCFLAGS="-march=athlon64")

#---------#
# Version #
#---------#
version = strftime("%Y-%m-%d")
env.Append(CPPDEFINES = [('VERSION', '\\"%s\\"' % version)])
#------#
# i18n #
#------#
if env['NLS'] == 1:
    env.Append(CCFLAGS="-DENABLE_NLS")
    env.Append(CCFLAGS="-DPACKAGE=\\\"VDrift\\\"")
    env.Append(CCFLAGS="-DLOCALEDIR=\\\"" + env['prefix'] + "/" + env['localedir'] + "\\\"")
#-----------------#
# Create Archives #
#-----------------#
src_dir_name = 'build/vdrift-%s-src' % version
bin_dir_name = 'build/vdrift-%s-bin' % version
# scons_local_tarball = 'tools/scons-local-0.96.1.tar.gz'

src_dir = env.Distribute(src_dir_name, ['SConstruct'])
bin_dir = env.Distribute(bin_dir_name, ['build/vdrift', 'tools/scripts/vdrift-install.sh'])

# env.TarCopy('build/scons-local/', scons_local_tarball)

src_archive = env.Tarball('%s.tar.bz2' % src_dir_name, src_dir)
bin_archive = env.Tarball('%s.tar.bz2' % bin_dir_name, bin_dir)

#----------------#
# Target Aliases #
#----------------#
env.Alias(target = 'install', source = [env['data_directory'], '$destdir$prefix/$bindir'])
env.Alias(target = 'src-package', source = src_archive)
env.Alias(target = 'bin-package', source = bin_archive)

#----------------#
# Subdirectories #
#----------------#

=== tools/scripts/Makefile ===

all:
	./configure

## vdrift 20141020

=== SConstruct ===
import os, sys, errno, SCons
from time import gmtime, strftime

#---------------#
# Build Options #
#---------------#
opts = Variables('vdrift.conf', ARGUMENTS)
opts.Add('arch', 'Target architecture to compile vdrift for (x86, 686, p4, axp, a64, prescott, nocona, core2)', 'x86')
opts.Add('destdir', 'Staging area to install VDrift to.  Useful for packagers. ', '')
opts.Add('builddir_release', 'Release build directory.', 'build')
opts.Add('builddir_debug', 'Debug build directory.', 'build')
opts.Add(BoolVariable('minimal', 'Only install minimal data (3 cars and 2 tracks)', 0))
opts.Add(BoolVariable('cache', 'Cache options in vdrift.conf', 1))
opts.Add(BoolVariable('release', 'Turn off debug option during build', 0))
opts.Add(BoolVariable('use_apbuild', 'Set this to 1 if you want to compile with apgcc to create an autopackage', 0))
opts.Add(BoolVariable('use_binreloc', 'Set this to 1 if you want to compile with Binary Relocation support', 1))
opts.Add(BoolVariable('os_cc', 'Set this to 1 if you want to use the operating system\'s C compiler environment variable.', 0))
opts.Add(BoolVariable('os_cxx', 'Set this to 1 if you want to use the operating system\'s C++ compiler environment variable.', 0))
opts.Add(BoolVariable('os_cxxflags', 'Set this to 1 if you want to use the operating system\'s C++ compiler flags environment variable.', 0))
opts.Add(BoolVariable('use_distcc', 'Set this to 1 to enable distributed compilation', 0))
opts.Add(BoolVariable('force_feedback', 'Enable force-feedback support', 0))
opts.Add(BoolVariable('profiling', 'Turn on profiling output', 0))
opts.Add(BoolVariable('efficiency', 'Turn on compile-time efficiency warnings', 0))
opts.Add(BoolVariable('verbose', 'Show verbose compiling output', 1)) 

#--------------------------#
# Create Build Environment #
#--------------------------#
# define a list of CPPDEFINES so they don't get mangled...
cppdefines = []
default_settingsdir = ".vdrift"
default_prefix = "/usr/local"
default_datadir = "share/games/vdrift/data"
default_localedir = "share/locale"
default_bindir = "bin"

#---------------#
# FreeBSD build #
#---------------#
if (sys.platform == 'freebsd6') or (sys.platform == 'freebsd7') or (sys.platform == 'freebsd8') or (sys.platform == 'freebsd9'):
    if 'LOCALBASE' in os.environ:
        LOCALBASE = os.environ['LOCALBASE']
    else:
        LOCALBASE = '/usr/local/'
    env = Environment(ENV = os.environ,
        CPPPATH = ['#src',LOCALBASE + '/include',LOCALBASE + '/include/bullet'],
        LIBPATH = ['.', '#lib', LOCALBASE + '/lib'],
        LINKFLAGS = ['-pthread','-lintl'],
        options = opts)
    check_headers = ['GL/gl.h', 'SDL2/SDL.h', 'SDL2/SDL_image.h', 'vorbis/vorbisfile.h', 'bullet/btBulletCollisionCommon.h']
    check_libs = []
    if 'CC' in os.environ:
        env.Replace(CC = os.environ['CC'])
    else:
        env.Replace(CC = "gcc")
    if 'CXX' in os.environ:
        env.Replace(CXX = os.environ['CXX'])
    else:
        env.Replace(CC = "g++")
    if 'CXXFLAGS' in os.environ:
        env.Append(CXXFLAGS = os.environ['CXXFLAGS'])

#------------#
# OS X build #
#------------#
elif sys.platform == 'darwin':
    opts.Add( ListVariable('universal', 
            'the target architectures to include in a universal binary.', 
            'none', ['ppc', 'i386']))
    opts.Add('SDK', 'the path to an SDK directory', '')

    env = Environment(ENV = os.environ,
        CPPPATH = ['#src', '#tools/osx/Frameworks', '#tools/osx/Frameworks/SDL.framework/Headers'],
        CCFLAGS = ['-Wall', '-Wextra'],
        CXXFLAGS = Split("$CCFLAGS -Wno-non-virtual-dtor -Wunused-parameter"),
        LIBPATH = ['.'],
        FRAMEWORKPATH = ['tools/osx/Frameworks/'],
        FRAMEWORKS = [ 'OpenGL' ],
        options = opts)

    # Setup universal binary support
    sdkfile = 'SDKSettings.plist'
    sdk_path = None
    
    if env['SDK']:
        sdk_path = FindFile( sdkfile, env['SDK'] )
    else:
        # check some reasonable locations
        sdk_path = FindFile( sdkfile,
            [ '/Developer/SDKs/MacOSX%s.sdk' % x for x in 
                [ '10.5', '10.4u' ] ] ) 

    for a in env['universal']:
        if not sdk_path:
            print 'Building a universal binary require access to an ' + \
                'SDK that has universal \nbinary support.If you know ' + \
                'the location of such an SDK, specify it using the \n"SDK" option'
            Exit(1)
        env.Append( CCFLAGS = ['-arch', a],  LINKFLAGS = ['-arch', a] )

    if (len(env['universal']) and sdk_path):
        from os.path import dirname
        sdk_path = dirname( str( sdk_path ) ) 
        env.Append( CCFLAGS = ['-isysroot', sdk_path], 
            LINKFLAGS = ['-Wl,-syslibroot,%s' % sdk_path] )

    # Configure reasonable defaults
    default_settingsdir = 'Library/Preferences/VDrift'
    default_prefix = "/Applications/VDrift"
    default_datadir = "data"
    default_bindir = ""

    check_headers = ['OpenGL/gl.h', 'SDL2/sdl.h']
    check_libs = []
    cppdefines.append(("_DEFINE_OSX_HELPERS"))

#---------------#
# Windows build #
#---------------#
elif ( 'win32' == sys.platform or 'cygwin' == sys.platform ):
    env = Environment(ENV = os.environ, tools = ['mingw'],
        CCFLAGS = ['-Wall', '-Wextra', '-Wno-unused-parameters', '-mwindows', '-mno-cygwin'],
        CPPPATH = ['#vdrift-win/include', '#vdrift-win/bullet'],
        LIBPATH = ['#vdrift-win/dll'],
		LINKFLAGS = ['-static-libgcc', '-static-libstdc++'],
        CPPDEFINES = ['_REENTRANT'],
        CC = 'gcc', CXX = 'g++',
        options = opts)
    check_headers = []
    check_libs = []

#-------------#
# POSIX build #
#-------------#
else:
    env = Environment(ENV = os.environ,
        CPPPATH = ['#src'],
        CCFLAGS = ['-Wall', '-Wextra', '-Wno-unused-parameter'],#, '-pthread'],
        LIBPATH = ['.', '#lib'],
        #LINKFLAGS = ['-pthread'],
        CC = 'gcc', CXX = 'g++',
        options = opts)
    # Take environment variables into account
    if os.environ.has_key('CXX'):
        env['CXX'] = os.environ['CXX']
    if os.environ.has_key('CXXFLAGS'):
        env['CXXFLAGS'] += SCons.Util.CLVar(os.environ['CXXFLAGS'])
    if os.environ.has_key('LDFLAGS'):
        env['LINKFLAGS'] += SCons.Util.CLVar(os.environ['LDFLAGS'])
    check_headers = ['GL/gl.h', 'SDL2/SDL.h', 'SDL2/SDL_image.h', 'vorbis/vorbisfile.h', 'curl/curl.h', 'bullet/btBulletCollisionCommon.h', 'bullet/btBulletDynamicsCommon.h']
    check_libs = []

if ARGUMENTS.get('verbose') != "1":
       env['ARCOMSTR'] = "\tARCH $TARGET"
       env['CCCOMSTR'] = "\tCC $TARGET"
       env['CXXCOMSTR'] = "\tCPP $TARGET"
       env['LINKCOMSTR'] = "\tLINK $TARGET"
       env['RANLIBCOMSTR'] = "\tRANLIB $TARGET"

#-------------------------------#
# General configurarion options #
#-------------------------------#
opts.Add('settings', 'Directory under user\'s home dir where settings will be stored', default_settingsdir )
opts.Add('prefix', 'Path prefix.', default_prefix)
# in most case datadir doesn't exsist => do not use PathOption (Fails on build)
opts.Add('datadir', 'Path suffix where where VDrift data will be installed', default_datadir) 
opts.Add('localedir', 'Path where VDrift locale will be installed', default_localedir)
opts.Add('bindir', 'Path suffix where VDrift binary executable will be installed', default_bindir)

# For the OSX package, but could be useful otherwise
env['EXECUTABLE_NAME'] = 'vdrift'
env['PRODUCT_NAME'] = 'vdrift'

#--------------#
# Save Options #
#--------------#
opts.Update(env)
if env['cache']:
    opts.Save('vdrift.conf', env)

#--------------------------------------------#
# distcopy and tarballer functions           #
# by Paul Davis <paul@linuxaudiosystems.com> #
#--------------------------------------------#
def distfile( src_root, file ):
    path = os.path.normpath( file.path )
    if ( len( src_root ) and path.startswith( src_root ) ):
        path = path[ len( src_root ) + 1 : ]

    return path

def distemit (target, source, env ):
    treedir = str ( target[0] ) 
    src_root = ''
    if ( len( target ) > 1 ): src_root = target[1].path
    target = [ os.path.join( treedir, distfile( src_root, f ) ) 
                for f in source ]

    # Links of all types must be omitted because scons doesn't
    # know how to handle them.  It can't check for existance
    # or traverse links to directories and who knows what else
    # jul. 27 2007
    for t,s in zip( target, source ):
        if os.path.islink( str( t ) ):
            if os.path.islink( str( s ) ):
                target.remove( t )
                source.remove( s )
            else:
                env.Execute( Delete( t ) )

    return ( target, source )

def distcopy (target, source, env):
    # converted from system wrapper to pure python function
    # to better support windows

    for t, s in zip( target, source ):
        t = os.path.dirname( str( t ) )
        if not os.path.exists( t ): 
            env.Execute( Mkdir( t ) )
        s = str( s )
        if ( os.path.islink( s ) and 
                not os.path.isabs( os.readlink( s ) ) ):
            os.symlink( os.readlink( s ), 
                        os.path.join( t, os.path.basename( s ) ) )
        else:
            env.Execute( Copy( t,  s ) )


    return

def tarballer (target, source, env):            
    cmd = 'tar -jcf "%s" -C "%s" .'  % ( str(target[0]), str(source[0]) )
    #cmd = 'tar -jcf ' + str (target[0]) +  ' ' + str(source[0]) + "  --exclude '*~' "
    print 'running ', cmd, ' ... '
    p = os.popen (cmd)
    return p.close ()

#----------------------------------#
# definitions file writer function #
#----------------------------------#
def write_definitions(cppdefs=[]):
    defs_file = open("src/definitions.h", "w")
    defs_file.write("#ifndef _DEFINITIONS_H\n")
    defs_file.write("#define _DEFINITIONS_H\n")
    for item in cppdefs:
        if len(item) == 2:
            defs_file.write("#define " + item[0] + " " + item[1] + "\n")
        else:
            defs_file.write("#define " + item + "\n")
    defs_file.write("#endif // _DEFINITIONS_H\n")
    defs_file.close()

dist_bld = Builder ( action = distcopy,
                    emitter = distemit,
                    target_factory = SCons.Node.FS.default_fs.Entry,
                    source_factory = SCons.Node.FS.default_fs.Entry,
                    multi = 1)

tarball_bld = Builder (action = tarballer,
                       target_factory = SCons.Node.FS.default_fs.Entry,
                       source_factory = SCons.Node.FS.default_fs.Entry)

env.Append (BUILDERS = {'Distribute' : dist_bld})
env.Append (BUILDERS = {'Tarball' : tarball_bld})

#--------------------------------------------------#
# Builder for exporting an svn directory           #
#--------------------------------------------------#
def exportvisit( srcfiles, dirname, entries):
    from os.path import join, isdir, islink
    
    srcfiles.extend( [ File( join( dirname, e ) ) for e in entries 
            if not isdir( join( dirname, e ) ) ] )
    srcfiles.extend( [ Dir( join( dirname, e ) ) for e in entries
            if islink( join(dirname, e ) ) and isdir( join( dirname, e ) ) ] )

def exportemit (target, source, env ):
    source_str = str( source[0] )
    target.append( Dir( os.path.dirname( source_str ) ) )
    if ( os.path.isdir( source_str ) ):
        source = []
        os.path.walk( source_str, exportvisit, source )

    return distemit( target, source, env )


export_bld = Builder( action = distcopy,
                      emitter = exportemit,
                      target_factory = Entry,
                      source_factory = Entry,
                      multi = 0 )
env.Append (BUILDERS = {'WorkingExport' : export_bld })

#--------------------------------------------------#
# Builder for untarring something into another dir #
#--------------------------------------------------#
def tarcopy(target, source, env):
    cmd = 'tar zxf ' + source + ' -C ' + target

=== tools/G25manage/Makefile ===
all : G25manage

G25manage: G25manage.c
	gcc -Wall -lusb -g3 -o G25manage G25manage.c

G25manage-static: G25manage.c
	gcc -Wall -o G25manage G25manage.c /usr/lib/libusb.a

clean:
	rm -rf G25manage

=== tools/modelconvert/SConstruct ===
env = Environment()

env.Append(LIBPATH = ['.'])
env.Append(CCFLAGS = ['-g3'])
#env.Append(CCFLAGS = ['-O1','-g3'])
env.Append(CPPPATH=['.', '../../include'])
#env.Append(LIBS = ['boost_thread-mt'])
env.Append(LIBS = ['GL', 'GLEW', 'glut'])
list = Split("""main.cpp
	../../src/model_joe03.cpp
	../../src/model_obj.cpp
	../../src/vertexarray.cpp
	../../src/joepack.cpp
	../../src/mathvector.cpp
	../../src/aabb.cpp
	../../src/opengl_utility.cpp
	../../src/model.cpp""")
env.Program('modelconvert', list)

=== debian/changelog ===
vdrift (20141020-1~mx17+1) mx; urgency=medium

  * Repackaged for MX 17.
  * Modified control & rules to use gcc-4.9
  * Enabled libglew-dev

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 14 Apr 2018 19:56:28 -0700

vdrift (20141020-1~getdeb1) trusty; urgency=medium

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Wed, 19 Nov 2014 20:24:48 +0100

vdrift (20140926-1~getdeb1) trusty; urgency=medium

  * New upstream version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Tue, 30 Sep 2014 20:11:22 +0200

vdrift (20140922-1~getdeb1) trusty; urgency=medium

  * New upstream version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Thu, 25 Sep 2014 21:46:11 +0200

vdrift (20140811-1~getdeb2) trusty; urgency=medium

  * New upstream version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Wed, 17 Sep 2014 21:32:46 +0200

vdrift (20140811-1~getdeb1) trusty; urgency=medium

  * New upstream version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Sun, 31 Aug 2014 21:32:46 +0200

vdrift (20120722-1~getdeb6~trusty) trusty; urgency=low

  * Rebuild for trusty

 -- Christoph Korn <christoph.korn@getdeb.net>  Sun, 06 Apr 2014 20:40:05 +0200

vdrift (20120722-1~getdeb5~raring) raring; urgency=low

  * Rebuild for raring.

 -- Christoph Korn <christoph.korn@getdeb.net>  Wed, 08 May 2013 22:26:40 +0200

vdrift (20120722-1~getdeb4~quantal) quantal; urgency=low

  * Rebuild against new bullet version.

 -- Christoph Korn <christoph.korn@getdeb.net>  Fri, 22 Mar 2013 20:08:59 +0100

vdrift (20120722-1~getdeb2) quantal; urgency=low

  * Rebuild for quantal

 -- Christoph Korn <christoph.korn@getdeb.net>  Sat, 20 Oct 2012 15:19:13 +0200

vdrift (20120722-1~getdeb1) precise; urgency=low

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Tue, 24 Jul 2012 19:59:20 +0200

vdrift (20111022-1~getdeb2~precise) precise; urgency=low

  * Rebuild for precise

 -- Christoph Korn <christoph.korn@getdeb.net>  Fri, 06 Apr 2012 14:28:09 +0200

vdrift (20111022-1~getdeb1) oneiric; urgency=low

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Tue, 15 Nov 2011 17:03:33 +0100

vdrift (20100630-1~getdeb2) lucid; urgency=low

  * debian/patches/opengl.patch: Replace glGenerateMipmap
    with glGenerateMipmapEXT (LP: #824472)

 -- Christoph Korn <christoph.korn@getdeb.net>  Thu, 11 Aug 2011 19:18:14 +0200

vdrift (20100630-1~getdeb1) lucid; urgency=low

  * New upstream version (LP: #606096)

 -- Christoph Korn <christoph.korn@getdeb.net>  Sat, 24 Jul 2010 22:12:47 +0200

vdrift (20090615-1~getdeb1) jaunty; urgency=low

  * Initial release

 -- Christoph Korn <c_korn@gmx.de>  Mon, 10 Aug 2009 14:23:11 +0200

=== debian/control ===
Source: vdrift
Section: games
Priority: optional
Maintainer: Christoph Korn <c_korn@gmx.de>
Build-Depends: debhelper (>= 9),
               gcc-4.9,
               g++-4.9,
               cpp-4.9,
               scons,
               lsb-release,
               libsdl2-dev,
               libsdl2-image-dev,
               libvorbis-dev,
               libbullet-dev,
               libcurl4-gnutls-dev
Standards-Version: 3.9.5
Homepage: http://vdrift.net/

Package: vdrift
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         vdrift-data (= ${source:Version})
Description: Cross-platform, open source driving simulation
 VDrift is a cross-platform, open source driving
 simulation made with drift racing in mind.

Package: vdrift-data
Architecture: all
Depends: ${misc:Depends}
Description: Cross-platform, open source driving simulation (data files)
 VDrift is a cross-platform, open source driving
 simulation made with drift racing in mind.
 .
 This package contains the data files.

=== debian/rules ===
#!/usr/bin/make -f

export SHELL=/bin/bash

# Build with gcc-4.9 on Stretch, Buster,Xenial, Yakkety, Zesty, and Horizon.
distrelease := $(shell lsb_release -cs)
ifeq ($(distrelease),$(filter $(distrelease),stretch buster xenial yakkety \
zesty Horizon))
export CC=gcc-4.9
export CXX=g++-4.9
export CPP=cpp-4.9
export LD=gcc-4.9
endif

%:
	dh $@

override_dh_auto_clean:
	find . -iname "*.o" -type f -delete
	rm -f .sconsign.dblite build/vdrift
	rm -rf .sconf_temp
	rm -rf data/locale/*/LC_MESSAGES/vdrift.mo

override_dh_auto_configure:

override_dh_auto_build:
	scons release=1

override_dh_auto_install:
	scons install prefix=/usr destdir=$(CURDIR)/debian/tmp bindir=games
	find $(CURDIR)/debian/tmp/usr/share/games/vdrift -type f -exec chmod -x {} \;

override_dh_install:
	dh_install --sourcedir=$(CURDIR)/debian/tmp --list-missing

=== debian/watch ===
version=3
opts="dversionmangle=s/([\d]{4})([\d]{2})([\d]{2})/$1-$2-$3/" \
http://sf.net/vdrift/vdrift-([-\d]+)\.tar\.bz2
